// ==UserScript==
// @name         题库自动化- 页面跳转操作
// @namespace    https://www.lichuanjiu.top/
// @version      3.0.2
// @description  用于题库自动化处理，在交卷完成页面跳转到查看解析页面
// @author       李传玖
// @match        https://tiku.kgc.cn/testing/paper/report/*

// @icon         https://www.google.com/s2/favicons?sz=64&domain=kgc.cn
// @grant        none
// ==/UserScript==

(function() {
    'use strict';
    setTimeout(() => {
        var total = document.querySelector("p.grays");
        var actual = document.querySelector("p.size");
        var totalNum = total.innerHTML.replace(/[^\d]/g, "");
        var wrongTopic =getCookie("wrongTopic");

        //判断是否全部正确
        if(actual.innerHTML != totalNum-wrongTopic){//表示该次答题没有全部正确，自动跳转到解析页面，获取答案
            
            document.getElementById("question1").click();
        }else{// 本次答题全部正确，自动进入下一个答题
           document.getElementById("againExam").click();
        }
    }, 500);
    function getCookie(name) {
        var cookies = document.cookie;
        var list = cookies.split("; "); // 解析出名/值对列表
        for (var i = 0; i < list.length; i++) {
            var arr = list[i].split("="); // 解析出名和值
            if (arr[0] == name){
                return decodeURIComponent(arr[1]); // 对cookie值解码
            }
        }
        return "";
    }
})();