// ==UserScript==
// @name         题库自动化-填写
// @namespace    https://www.lichuanjiu.top/
// @version      3.0.2
// @description  用于题库自动化处理
// @author       李传玖
// @match        https://tiku.kgc.cn/*

// @icon         https://www.google.com/s2/favicons?sz=64&domain=kgc.cn
// @grant        none
// ==/UserScript==

(function () {
    'use strict';
    // Your code here...
    //定义用户脚本版本
    var version = "3.0.2";
    //判断用户位置是否是用户首页
    var nowURL = window.location.href;
    //用户首页位置
    var userHome = "https://tiku.kgc.cn/testing/index";
    if (nowURL.indexOf(userHome) != -1) {//确定用户在首页
        //获取用户ID
        var userID = getIDNum(getID(nowURL));
        //将用户ID添加到Cookie中
        // setCookie("tempUserID", userID);
        localStorage.setItem("tempUserID", userID);
    }
    //读取用户ID
    var ID = localStorage.getItem("tempUserID");
    //判断用户是否激活脚本
    var key = getKey(ID);
    var userName = document.getElementById("userName").innerHTML;
    let Email = getCookie("examLoginName");
    let Phone = getCookie("examLoginUserName");
    if (key != "-1") {
        if (key == "-2") {
            alert("当前脚本已过期，请更新最新可用脚本");
            throw new Error("当前脚本已过期，请更新最新可用脚本");
        } else if (key == "-3") {
            addUser(ID, userName, Email, Phone)
        } else {
            // setCookie("userKey", key);
            localStorage.setItem("userKey", key);
            if (!(nowURL == "https://tiku.kgc.cn/testing/unified/exam")) {
                document.body.onkeydown = function (e) {
                    if (e.ctrlKey && e.altKey && e.code == "KeyJ") {
                        showMain();
                    }
                }
                //创建dialog对象
                var dialog = document.createElement("dialog");
                //创建style元素
                var style = document.createElement("style");
                dialog.setAttribute("id", "Mydialog");
                dialog.innerHTML = '<div class="input"><h1>欢迎使用题库脚本服务</h1><label for="switch"> 开关</label><input type="checkbox" name="switch" id="switch" ><label for="accuracy">正确率</label><input type="text" name="accuracy" id="accuracy"  value="100"></div><div class="last"><button  id="MyBtnConfirm">确定</button></div><div class="copy"><span>&copy; <a href="https://itziyuanwang.top" target="_blank">IT资源网产品</a></span> <span><a href="https://www.itziyuanwang.top/supportOur.php" target="_blank">赞助开发</a></span></div>'
                style.innerHTML = '#Mydialog {z-index: 99999; background-color: #fff; border-radius: 10px; box-shadow: 0 0 10px rgba(0, 0, 0, 0.2); position: fixed;top: 50%;transform: translate(0, -50%);padding: 20px;text-align: center;margin: auto;} #Mydialog label {display: block; margin-top: 0.3em;font-weight: bold;} #Mydialog input[type="checkbox"], #Mydialog input[type="text"] {width: 30%; padding: 10px;margin-top: 0.2em; border: 1px solid #ccc;cursor: pointer; border-radius: 5px;}#Mydialog input[type="checkbox"]:focus, #Mydialog input[type="text"]:focus {outline: none;border-color: #007BFF;}#Mydialog button {background-color: #007BFF;color: #fff;padding: 10px 20px; border: none; border-radius: 5px;cursor: pointer; margin-top: 20px;}#Mydialog button:hover {background-color: #005fc4;}#Mydialog button:active {animation: btnactive 0.5s linear reverse;}@keyframes btnactive {0% {background-color: #005fc4;}50% {background-color: #00254d;}100% {background-color: #005fc4;}}#Mydialog .copy {text-align: center;margin-top: 20px; }#Mydialog .copy a {text-decoration: none;color: #007BFF;}#Mydialog .copy a:hover {text-decoration: underline;}';
                //向页面中添加元素
                document.body.append(dialog);
                document.head.append(style);
                refreshBtnAppearance();
            }
        }
    } else {
        // setCookie("userKey", "-1");
        localStorage.setItem("userKey", "-1");
        addUser(ID, userName, Email, Phone);
        if (nowURL.indexOf("login") == -1) {//用户登录不弹窗
            alert("抱歉，当前用户尚未激活，无法提供脚本服务！！！");
        }
        throw new Error('用户未激活脚本，无法提供服务！！！');
    }
    var all = null;
    analyzeTheTopic();
    //显示初始化信息
    loadMessages(localStorage.getItem("tempUserID"));
    function analyzeTheTopic() {
        //定义两个变量存储信息判断操作
        var testAddress = "https://tiku.kgc.cn/testing/exam/paper"; //课程复习型地址
        var testAddress_1 = "https://tiku.kgc.cn/testing/exam/createSkillPaper" //专项技能型地址
        //获取当前所在位置
        if (!(nowURL == testAddress || nowURL == testAddress_1)) {
            return;
        }
        if (!getUserScriptStatus()) {
            return;
        }
        initializationAccuracy();
        setTimeout(() => {
            if (getUserScriptStatus()) {
                all = document.getElementsByClassName("sec");
                var tempi = 0;
                console.log(all.length);
                var idList = "";
                for (var i = 0; i < all.length; i++) {
                    var temppre = all[i].getElementsByTagName("pre");
                    var thisze = temppre[0].getElementsByTagName("img");
                    if (thisze.length == 1) {
                        console.log(thisze[0].src);
                        var params = queryURLparamsRegEs5(thisze[0].src)["relativePath"];
                        var encryptionId = getID(params);//到这里我们获取到了题目的加密ID

                        //获取用户ID
                        var tempUserID = localStorage.getItem("tempUserID");

                        //获取真实ID
                        var realID = getID(encryptionId) + "/" + (getIDNum(encryptionId) - tempUserID);

                        idList = idList + realID + ";";
                        console.log(idList);

                    }
                }
                operation(idList, localStorage.getItem("tempUserID"));
            }
        }, 2000);
        setTimeout(() => {
            if (getUserScriptStatus()) {

                $.ajax({ type: "get", dataType: "text", url: "https://tiku.kgc.cn/testing/gra/now", success: function (data) { } });
                //点击交卷
                document.getElementById("putIn").click();
                document.getElementById("putInBtn").click();
            }
        }, 3000);
        setTimeout(() => {
            if (getUserScriptStatus()) {
                //关闭提示
                document.getElementById("closeReturnDialog").click();
            }
        }, 8000);

    }
    function operation(idList, key) {

        var data = new FormData();
        data.append("id", idList);
        data.append("key", key);

        //创建异步对象
        var xhr = new XMLHttpRequest();
        //设置请求的类型及url
        xhr.open('post', 'https://kgc.tiku.lichuanjiu.top/api/tiku/getAnswers.php');
        //post请求一定要添加请求头才行不然会报错
        // xhr.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
        //发送请求
        xhr.send(data);
        xhr.onreadystatechange = function () {
            // 这步为判断服务器是否正确响应
            if (xhr.readyState == 4 && xhr.status == 200) {
                //拿到服务器的数据,并解析
                var result = parseData(xhr.responseText);
                //填写数据到页面
                fillIn(result);
                console.log(result);
            }
        };
    }

    // https://tiku.kgc.cn/testing/cdn/getImage?relativePath=0012000/1543303458188/616904c46eec36797abd9929c5dd34bf.jpg&imageType=2
    //获得参数
    function queryURLparamsRegEs5(url) {
        let obj = {}
        let reg = /([^?=&]+)=([^?=&]+)/g
        url.replace(reg, function () {
            obj[arguments[1]] = arguments[2]
        })
        return obj
    }
    function getID(parameter) {
        var index = parameter.lastIndexOf("/");
        var ID = parameter.substr(0, index);
        return ID;
    }
    function getIDNum(encryptionId) {
        var index = encryptionId.lastIndexOf("/");
        var IDNum = encryptionId.substr(index + 1, encryptionId.length);
        return IDNum;
    }
    //解析来自后台的数据
    function parseData(data) {
        //去除data中最后一个“;”
        var index = data.lastIndexOf(";");
        data = data.substr(0, index);
        var pData = data.split(";");
        return pData;
    }
    //将参数填写到页面
    function fillIn(parameter) {
        var arr = ["A", "B", "C", "D", "E"];
        //获取根据用户输入的正确率获取的需要填写的错题量
        // var wrongTopic = getCookie("wrongTopic");
        var wrongTopic = localStorage.getItem("wrongTopic");
        for (var i = 0; i < parameter.length; i++) {
            //判断题目是否在数据库中记录
            if (parameter[i] != -1) {
                var listOfOptions = all[i].getElementsByTagName("input");
                //判断题目是多选还是单选
                if (parameter[i].length > 2) {//这是一道多选题
                    var multipleSelectionList = parameter[i].split(",");
                    multipleSelectionList.forEach(element => {
                        var index = arr.map(item => item).indexOf(element);
                        listOfOptions[index].click();
                    });
                } else {//单选题
                    var index = arr.map(item => item).indexOf(parameter[i]);
                    //扰动正确答案，达到控制正确率的效果
                    if (wrongTopic > 0) {
                        if (index == 0) {
                            index = 3;
                        } else {
                            index--;
                        }
                        wrongTopic--;
                    }

                    listOfOptions[index].click();

                }
            }
        }
    }
    function getCookie(name) {
        var cookies = document.cookie;
        var list = cookies.split("; "); // 解析出名/值对列表
        for (var i = 0; i < list.length; i++) {
            var arr = list[i].split("="); // 解析出名和值
            if (arr[0] == name) {
                return decodeURIComponent(arr[1]); // 对cookie值解码
            }
        }
        return "";
    }
    function getKey(userID) {
        //创建提交数据，在其中添加数据
        var data = new FormData();
        data.append("id", userID);
        data.append("version", version);

        //创建异步对象
        var xhr = new XMLHttpRequest();
        xhr.open("post", "https://kgc.tiku.lichuanjiu.top/api/tiku/getKey.php", false);
        //发送请求数据
        xhr.send(data);
        if (xhr.status == 200) {
            return xhr.responseText;
        }
    }
    // 发送添加用户请求
    function addUser(AID, Name, Email, Phone) {
        var data = new FormData();
        data.append("AID", AID);
        data.append("Name", Name);
        data.append("Email", Email);
        data.append("Phone", Phone);
        var xhr = new XMLHttpRequest();
        xhr.open("post", "https://kgc.tiku.lichuanjiu.top/api/tiku/addUser.php", false);
        //  xhr.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
        xhr.send(data);
    }

    //计算正确率，写入cookie
    function initializationAccuracy() {
        all = document.getElementsByClassName("sec");
        //获取百分值
        var accuracy = localStorage.getItem("accuracy");
        //计算应该错误和正确的题量
        var wrongTopic = parseInt(all.length - ((accuracy / 100) * all.length));
        console.log("正确率：" + accuracy + "..." + wrongTopic);
        // setCookie("wrongTopic", wrongTopic);
        localStorage.setItem("wrongTopic", wrongTopic);
    }
    //按钮状态刷新
    function refreshBtnAppearance() {
        document.getElementById("switch").checked = getUserScriptStatus();
        document.getElementById("accuracy").value = localStorage.getItem("accuracy");
    }
    //获取用户脚本状态
    function getUserScriptStatus() {
        //读取用户脚本状态
        var state = localStorage.getItem("scriptStatus");
        return state == "1" ? true : false;
    }
    //显示服务器重要通知
    function loadMessages(id) {
        //当用户在首页时显示
        if (window.location.href.indexOf("index") > 0 || window.location.href.indexOf("classExam") > 0) {
            var data = new FormData();
            //追加数据到表单
            data.append("id", id);
            //创建异步对象
            var xhr = new XMLHttpRequest();
            xhr.open("post", "https://kgc.tiku.lichuanjiu.top/api/tiku/getMessages.php", false);
            //发送请求数据
            xhr.send(data);
            if (xhr.status == 200) {
                var messagesData = JSON.parse(xhr.responseText);
                if (messagesData.notice.value != "-1" && messagesData.notice.value.length > 2) {
                    showNotices(messagesData.noticeTitle.value, messagesData.notice.value);
                }
                if (messagesData.advertisingAddress.value != "-1" && messagesData.advertisingAddress.value.length > 2) {
                    showAdvertisement(messagesData.advertisingAddress.value, messagesData.advertisingTips.value);
                }
            }
        }
    }
    function showNotices(noticeTitle, noticeData) {
        const dialogStyleStr = "width: 30%; padding: 0px; padding: 0px; position: absolute; margin: auto;text-align: center; border-width: 0px; box-shadow:0px 8.8px 3.7px rgba(0, 0, 0, 0.068),0px 15.3px 8.3px rgba(0, 0, 0, 0.1),0px 21.6px 16.5px rgba(0, 0, 0, 0.122),0px 45px 53px rgba(0, 0, 0, 0.15);border-radius: 10px;";
        const pStyleStr = "font-size: 2em; font-weight: bold;";
        const divStyleStr = "padding: 1em;";
        const btnStyleStr = "background-color: #007BFF;color: #fff;padding: 10px 20px;border: none;border-radius: 5px;cursor: pointer;margin-top: 20px;";
        //创建dialog 元素
        let dialog = document.createElement("dialog");
        //创建p元素
        let p = document.createElement("p");
        //创建显示通知内容div
        let div = document.createElement("div");
        //创建btn元素
        let btn = document.createElement("button");


        //为创建的元素添加样式
        dialog.setAttribute("style", dialogStyleStr);
        p.setAttribute("style", pStyleStr);
        div.setAttribute("style", divStyleStr);
        div.setAttribute("id", "importantNoticeContent");
        btn.setAttribute("style", btnStyleStr);
        btn.setAttribute("id", "importantNoticeContentBtn");

        //p默认数据
        p.innerHTML = noticeTitle;
        //div添加数据
        div.innerHTML = noticeData;
        //btn文字
        btn.innerText = "关闭";
        //将元素添加到dialog中
        dialog.appendChild(p);
        dialog.appendChild(div);
        dialog.appendChild(btn);
        //将dialog添加到页面body中
        document.body.append(dialog);
        //为btn添加点击事件
        btn.onclick = function () {
            dialog.close();
        }
        dialog.showModal();
    }
    function showAdvertisement(url, tips) {
        const dialogStyleStr = "width: 60%;height: 100%;border: 0px;position: absolute;text-align: center; margin: auto;";
        const iframeStyleStr = "width: 100%;height: 90%;border: 0px;";
        const closeBtnStyleStr = " width: 100px;height: 30px;background-color: rgb(8, 179, 8);border-radius: 5px;color: white;font-size: 20px;cursor: pointer;border-width: 0px;";
        const textStyleStr = "width: 100%; text-align: center; padding: 0px; margin: 0px ;border: 0px; font-size:2.5em; font-weight: bold;";
        // 创建一个dialog元素
        var dialog = document.createElement("dialog");
        // 设置dialog的样式
        dialog.setAttribute("style", dialogStyleStr);
        // 创建一个iframe 元素
        var iframe = document.createElement("iframe");
        // 设置iframe的src
        iframe.setAttribute("src", url);
        iframe.setAttribute("style", iframeStyleStr);

        // 创建一个closeBtn元素
        var closeBtn = document.createElement("button");
        // 设置closeBtn的样式
        closeBtn.setAttribute("style", closeBtnStyleStr);
        // 设置closeBtn的文本
        closeBtn.textContent = "关闭";
        // 创建一个text元素
        var text = document.createElement("h1");
        // 设置text的样式
        text.setAttribute("style", textStyleStr);
        // 设置text的文本
        text.textContent = tips;

        dialog.appendChild(iframe);
        // 将closeBtn添加到dialog中
        dialog.appendChild(closeBtn);
        // 将text添加到dialog中
        dialog.appendChild(text);
        // 将dialog添加到body中
        document.body.append(dialog);
        // 点击closeBtn时关闭dialog
        closeBtn.onclick = function () {
            dialog.close();
        }
        //显示dialog
        dialog.showModal();
    }


    function showMain() {
        if (dialog.open) {
            return;
        }
        dialog.showModal();
        document.getElementById("MyBtnConfirm").onclick = btnConfirm;
        document.getElementById("accuracy").oninput = function () {
            inputCheck(this);
        };
    }
    function btnConfirm() {
        //获取元素选择框
        let checkbox = document.getElementById("switch").checked;
        let accuracy = document.getElementById("accuracy").value;
        if (isNaN(accuracy) || accuracy > 100 || accuracy < 1) {
            accuracy = 100;
        }
        if (!getUserScriptStatus() && checkbox) {
            //写入cookie
            localStorage.setItem("scriptStatus", checkbox ? "1" : "-1");
        }
        document.getElementById("accuracy").value = accuracy;
        localStorage.setItem("scriptStatus", checkbox ? "1" : "-1");
        localStorage.setItem("accuracy", accuracy);
        if (getUserScriptStatus()) {

            analyzeTheTopic();
        }
        //关闭dialog
        dialog.close();
    }
    function inputCheck(element) {
        element.value = element.value.replace(/[^\d]/g, '');
        if (element.value > 100) {
            element.value = 100;
            return;
        }
        if (element.value < 1 && element.value != "") {
            element.value = 1;
        }
    }
})();