// ==UserScript==
// @name         题库自动化-收集数据
// @namespace    https://www.lichuanjiu.top/
// @version      3.0.2
// @description  用于题库自动化处理-用于收集题目数据
// @author       李传玖
// @match        https://tiku.kgc.cn/testing/paper/solutions/*

// @icon         https://www.google.com/s2/favicons?sz=64&domain=kgc.cn
// @grant        none
// ==/UserScript==

(function() {
    'use strict';

    setTimeout(() => {
        var all = document.getElementsByClassName("sec");
        var idList = "";
        for (var i = 0; i < all.length; i++) {
            var thisze = all[i].getElementsByTagName("img");
            if (thisze.length > 0) {
                var params = queryURLparamsRegEs5(thisze[0].src)["relativePath"];
                var id = getID(params);
                //拿到了题目编号,我们还需要获取题目答案
                var answer = all[i].getElementsByTagName("label")[0];
                var answerText = answer.innerHTML;

                // if(!(reg.test(str))){

                // }


                var correctOption = answer.firstElementChild.innerHTML.replace(/\s*/g,"");

                console.log(correctOption);

                idList = idList + id + "|" + correctOption + ";";
                //
                console.log(idList);
            }
        }
        operation(idList);
    }, 1500);
    setTimeout(() => {
        document.getElementById("againExam").click();
    }, 2000);

    function operation(idList){
        //创建异步对象
        var xhr = new XMLHttpRequest();
        //设置请求的类型及url
        xhr.open('post', 'https://kgc.tiku.lichuanjiu.top/api/tiku/upData.php');
        //post请求一定要添加请求头才行不然会报错
        xhr.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
        //发送请求
        xhr.send('id=' + idList);
        xhr.onreadystatechange = function () {
            // 这步为判断服务器是否正确响应
            if (xhr.readyState == 4 && xhr.status == 200) {
                console.log(xhr.responseText);
            }
        };
    }

    function queryURLparamsRegEs5(url) {
        let obj = {}
        let reg = /([^?=&]+)=([^?=&]+)/g
        url.replace(reg, function () {
            obj[arguments[1]] = arguments[2]
        })
        return obj
    }
    function getID(parameter) {
        var index = parameter.lastIndexOf("/");
        var ID = parameter.substr(0, index);
        return ID;
    }
})();
